﻿var http = require('http');
var mysql = require('mysql');
var url = require('url');
var sha256 = require('sha256')
var nodemailer = require('nodemailer');
var multiparty = require('multiparty');
var fs = require("fs");
var sizeOf = require('image-size');
var shell = require('shelljs');

var pool = mysql.createPool({
  connectionLimit: 30,
  host: '127.0.0.1',
  user: 'root',
  password: '**********',
  database: 'redpen'
});

var transport = nodemailer.createTransport({
  service: 'gmail',
  auth: {
    user: 'aglaya.pro.redpen@gmail.com',
    pass: '*********'
  }
});


function randomString(len1, len2) {
  var chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
  var result = "";
  for (var i = 0; i < (len1 + Math.floor(Math.random() * ((len2 || len1) - len1))); i++) {
    result += chars.charAt(Math.floor(Math.random() * chars.length));
  }
  return result;
}

function parseCookies(request) {
  var list = {};
  var rc = request.headers.cookie;

  rc && rc.split(';').forEach(function(cookie) {
    var parts = cookie.split('=');
    list[parts.shift().trim()] = decodeURI(parts.join('='));
  });

  return list;
};

var server = http.createServer(function(req, res) {
  console.log('Processing request');

  var parsed = url.parse(req.url, true);
  var cookies = parseCookies(req);

  console.log("pathame:", parsed.pathname);
  console.log("cookies:", cookies);
  console.log("query:", parsed.query);

  //console.log("req:", req);

  if (parsed.pathname == "/register.json") {
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var email = parsed.query["email"];
    var name = parsed.query["name"];
    var role = parsed.query["role"];
	var invitator = parsed.query["invitator"];
	
    var password = randomString(7, 10);
    var hash = sha256(email + password);

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      }
	  
	  if (invitator) {    
		
        connection.query('SELECT ID, name from redpen.users WHERE email = ? and role = \'teacher\'', [invitator], function(err, rows) {
          if (err) {
            res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
            connection.release();
            return;
          }

          if (!rows || !rows.length) {
            res.end(JSON.stringify({code:100, message: 'El seu invitador ecnara no s\'ha registrat!'}));
            connection.release();
            return;
          }
		  
		  var invitatorID = rows[0]["ID"];
		  var invitatorName = rows[0]["name"];
		  
          connection.query('INSERT INTO redpen.users (email, name, role, password) VALUES (?, ?, ?, ?)', [email, name, role, hash], function(err) {
            if (err) {
              console.log('Error while performing Query.', err);
              res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
              connection.release();
              return;
            };
			
            connection.query('INSERT INTO redpen.studentsandteachers (student, teacher) ' +
              'SELECT s.ID, ? FROM redpen.users s WHERE s.email = ?', [invitatorID, email], function(err) {
			
              connection.release();
              if (err) {
                console.log('Error while performing Query.', err);
                res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
                return;
              };
				
              transport.sendMail({
                from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
                to: email,
                subject: 'La seva contrasenya nova!',
                text: 'Hola, ' + name + '! Gracies per enregistrar-se al nostre servei! Aquesta es la seva contrasenya: ' + password
                }, function(err, info) {
                  if (err) {
                    console.log('Error while sending mail.', err)
                    res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
                    return;
                  };
				  
                  transport.sendMail({
                    from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
                    to: invitator,
                    subject: 'Un estudiant nou!',
                    text: 'Hola, ' + invitatorName + '! El seu estudiant ' + name + " (" + email + ") ha registrat!" 
                  }, function(err, info) {
                    if (err) {
                      console.log('Error while sending mail.', err);
                      res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
                      return;
                    };
                    res.end(JSON.stringify({OK: true}));
                  });
              });
            });
	      });	
		}); 
	  } 

      else	  
      connection.query('INSERT INTO redpen.users (email, name, role, password) VALUES (?, ?, ?, ?)', [email, name, role, hash], function(err) {
        connection.release();
        if (err) {
          console.log('Error while performing Query.', err);
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        transport.sendMail({
          from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
          to: email,
          subject: 'La seva contrasenya nova!',
          text: 'Hola, ' + name + '! Gracies per enregistrar-se al nostre servei! Aquesta es la seva contrasenya: ' + password
        }, function(err, info) {
          if (err) {
            console.log('Error while sending mail.', err)
            res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
            return;
          };
          res.end(JSON.stringify({OK: true}));
        });
      });

    });

  }
  else if (parsed.pathname == "/restore.json") {
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var email = parsed.query["email"];
    var password = randomString(7, 10);
    var hash = sha256(email + password);

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('SELECT ID, name from redpen.users WHERE email = ?', [email], function(err, rows) {
        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          connection.release();
          return;
        }

        if (!rows || !rows.length) {
          res.end(JSON.stringify({code:100, message: 'Encara no ha registrat! Intenti enregistrar!'}));
          connection.release();
          return;
        }

        var name = rows[0]["name"];
        var ID = rows[0]["ID"];

        connection.query('UPDATE redpen.users SET password = ? WHERE ID = ?', [hash, ID], function(err) {
          connection.release();
          if (err) {
            res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
            return;
          }

          transport.sendMail({
            from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
            to: email,
            subject: 'Restauracio de la contrasenya',
            text: 'Hola, ' + name + '! Aquesta es la seva contrasenya nova: ' + password
          }, function(err, info) {
            if (err) {
              res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
              return;
            }
            res.end(JSON.stringify({OK: true}));
          });
        });
      }); 
    });
  }
  else if (parsed.pathname == "/login.json") {
    var email = parsed.query["email"];
    var password = parsed.query["password"];
    var hash = sha256(email + password);

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('SELECT ID, name, role, email from redpen.users WHERE email = ? and password = ?', [email, hash], function(err, rows) {
        console.log(email, hash);

        if (err) {
          console.log(err);
          connection.release();
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        if (!rows || !rows.length) {
          console.log("!rows");
          connection.release();
          res.end(JSON.stringify({code:100, message: 'La contrasenya o el correu és incorrecte!'}));
          return;
        };

        var name = rows[0]["name"];
        var ID = rows[0]["ID"];
        var role = rows[0]["role"];
        var email = rows[0]["email"];

        var cookie = randomString(32);
        var expires = new Date();
        expires.setMonth(expires.getMonth() + 1);

        res.writeHead(200, {
          'Content-Type': 'text/plain; charset=UTF-8',
          'Set-Cookie': 'HTTPID=' + cookie + '; expires=' + expires.toGMTString() + '; path=/'
        });

        connection.query('INSERT INTO redpen.sessions (cookie, user) VALUES (?, ?)', [cookie, ID], function(err) {
          connection.release();
          if (err) {
            res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
            return;
          }

          console.log("Session created!! Cookie set:", cookie);
          res.end(JSON.stringify({OK: true, name: name, role: role, email: email}));
        });
      });
    });
  }
  
  else if (parsed.pathname == "/whoami.json") {

    pool.getConnection(function(err, connection) {
      if (err) {
        //connection.release();
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('SELECT u.ID, u.name, u.role, u.email from redpen.sessions s inner join redpen.users u on u.ID = s.user WHERE s.cookie = ?', [cookies["HTTPID"] || ""], function(err, rows) {

        connection.release();
        

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        if (!rows || !rows.length) {
          res.end(JSON.stringify({code:100, message: 'you are stranger'}));
          return;
        }

        var name = rows[0]["name"];
        var role = rows[0]["role"];
        var email = rows[0]["email"];
        var ID = rows[0]["ID"];

        res.end(JSON.stringify({OK: true, name: name, role: role, email: email, ID: ID}));
      });
    });
  }

  else if (parsed.pathname == "/mylist.json"){

    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('select ID, className from teacherclass where teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)',
        [cookies["HTTPID"] || ""], function(err, rows) {

          if (err) {
            connection.release();
            res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
            return;
          };

          var classes = rows;

           connection.query('SELECT t.student, u.name, u.email, t.teacherclass FROM redpen.studentsandteachers t ' +
             'inner join redpen.users u on u.ID = t.student ' +
            'WHERE t.teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?) ORDER BY u.name',
            [cookies["HTTPID"] || ""], function(err, rows) {

              if (err) {
               connection.release();
               res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
               return;
              };

              var students = rows;
    
              connection.query('SELECT w.ID, w.title, w.student, w.statement, w.createtime, w.lastupdatetime, (select count(*) from redpen.images i where i.work = w.ID) images, ' + 
                ' (select sum(i.score) from redpen.images i where i.work = w.ID) score FROM redpen.works w ' +
                'WHERE teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?) and NOT w.statement = \'draft\' ORDER BY w.lastupdatetime DESC', [cookies["HTTPID"] || ""], function(err, rows) {
      
                connection.release();
 
                if (err) {
                 res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
                 return;
                };

                res.end(JSON.stringify({OK: true, classes: classes, students: students, works: rows}));
              });

            });

        });
    });

  }

  else if (parsed.pathname == "/createclass.json") {

    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var classname = parsed.query["classname"];
 
    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('INSERT INTO redpen.teacherclass (className, teacher) VALUES (?, (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?))',
        [classname, cookies["HTTPID"] || ""], function(err) {

        if (err) {
          connection.release();
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        connection.query('select LAST_INSERT_ID() ID', [], function(err, rows) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        var ID = rows[0]["ID"]

        res.end(JSON.stringify({OK: true, ID: ID}));

       });
      });
    });
  }

  else if (parsed.pathname == "/deletework.json"){
    
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var ID = parsed.query["id"]
    
    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };
     
      connection.query('DELETE FROM redpen.works WHERE ID = ? and statement = \'draft\'', [ID], function(err) {
        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Delete error'}));
          console.log("deleteError", err)
          return;
        }
      });
    });
    res.end(JSON.stringify({OK: true}));
  }

  else if (parsed.pathname == "/studentsearch.json"){

    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });
    
     pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };
     
      var emails = parsed.query["emails"].split(";");
      var students = [];
      var addedNumber = 0;
      var notFound = [];
      var name = "";
      var email = "";

      var iterator = function(){

        if (emails.length) {

          connection.query('SELECT u.ID, u.email, u.name, case when exists(SELECT 1 from redpen.studentsandteachers s WHERE s.student = u.ID ' + 
            'and teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)) then 1 else 0 end addedStudents  FROM redpen.users u WHERE u.email = ?', [cookies["HTTPID"] || "", emails[0]], function(err, rows) {

            if (err) {
              connection.release();
              res.end(JSON.stringify({code:100, message: 'Search error'}));
              console.log("searchError", err)
              return;
            };

            if (!rows.length){
              notFound.push(emails[0]);
              emails.shift();
              iterator();
              return;
            };

            if (rows[0].addedStudents == "1"){
              addedNumber++;
              emails.shift();
              iterator();
              return;
            };       
 
            name = rows[0]["name"];
            email = rows[0]["email"];
            var student = {
              ID: rows[0]["ID"],
              name: name,
              email: email
            };

            connection.query('INSERT INTO redpen.studentsandteachers (student, teacher) ' +
              'SELECT ?, s.user FROM redpen.sessions s WHERE s.cookie = ?', [student.ID, cookies["HTTPID"] || ""], function(err) {

              if (err) {
                connection.release();
                console.log("err", err);
                res.end(JSON.stringify({code:100, message: 'Insert error'}));
                return;
              };


            });

            connection.query('SELECT u.name FROM redpen.users u WHERE u.ID = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)', [cookies["HTTPID"] || ""], function(err, rows) {

              if (err) {
                connection.release();
                console.log("err", err);
                res.end(JSON.stringify({code:100, message: 'mail error'}));
                return;
              };
              
              transport.sendMail({
                from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
                to: email,
                subject: 'Un prosessor t\'ha afegit a la seva llista',
                text: 'Hola, ' + name + '! El professor ' + rows[0]["name"] + ' t\'ha afegit a la seva llista d\'alumnes!'
                }, function(err, info) {
                  if (err) {
                    console.log('Error while sending mail.', err)
                    res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
                  };
                });
              
           

              emails.shift();
              students.push(student);
              iterator();              
            });
          

          });

        }
        else {
          connection.release();
          res.end(JSON.stringify({OK: true, students: students, added: addedNumber, notfound: notFound}));
        };

      };

      iterator();

    });
  }

  else if (parsed.pathname == "/deleteclass.json"){

    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });
   
    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };
     
      var ID = parsed.query["ID"];

      connection.query('DELETE FROM redpen.teacherclass WHERE ID = ?', [ID], function(err, rows) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Aquesta classe ja és suprimida!'}));
          return;
        };

        res.end(JSON.stringify({OK: true}));
      });
    });
  }

  else if (parsed.pathname == "/deletelink.json"){

    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });
    
    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };
     
      var id = parsed.query["student"];
      var name = "";
      var email = "";

      connection.query('SELECT u.name, u.email FROM redpen.users u WHERE u.ID = ?', [id], function(err, rows) {
        if (err) {
          connection.release();
          console.log("err", err);
          res.end(JSON.stringify({code:100, message: 'mail error'}));
          return;
        };

        name = rows[0]["name"];
        email = rows[0]["email"];
      });

      connection.query('DELETE FROM redpen.studentsandteachers WHERE student = ? and teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)', [id, cookies["HTTPID"] || ""], function(err) {

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };
      });

      connection.query('SELECT u.name FROM redpen.users u WHERE u.ID = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)', [cookies["HTTPID"] || ""], function(err, rows) {

        connection.release();

        if (err) {
          console.log("err", err);
          res.end(JSON.stringify({code:100, message: 'mail error'}));
          return;
        };
           
        transport.sendMail({
          from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
          to: email,
          subject: 'Un prosessor t\'ha suprimit de la seva llista',
          text: 'Hola, ' + name + '! El professor ' + rows[0]["name"] + ' t\'ha suprimit de seva llista d\'alumnes!'
        }, function(err, info) {
          if (err) {
            console.log('Error while sending mail.', err)
            res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
          };
        });
        res.end(JSON.stringify({OK: true}));
      });
    });
  }

  else if (parsed.pathname == "/addinclass.json"){
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var studentid = parsed.query["student"];
    var classid = parsed.query["class"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('UPDATE redpen.studentsandteachers SET teacherclass = ? WHERE student = ? and teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)', [classid,  studentid, cookies["HTTPID"] || ""], function(err) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        res.end(JSON.stringify({OK: true}));
      });
    });
  }

  else if (parsed.pathname == "/renameclass.json"){
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var classid = parsed.query["class"];
    var name = parsed.query["name"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('UPDATE redpen.teacherclass SET className = ? WHERE ID = ? and teacher = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)',
        [name, classid, cookies["HTTPID"] || ""], function(err) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        res.end(JSON.stringify({OK: true}));
      });
    });
  }


  else if (parsed.pathname == "/changeprofile.json"){
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var name = parsed.query["name"];
    var email = parsed.query["email"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('UPDATE redpen.users SET name = ?, email = ? WHERE ID = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?)',
        [name, email, cookies["HTTPID"] || ""], function(err) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        res.end(JSON.stringify({OK: true}));
      });
    });
  }

  else if (parsed.pathname == "/myteachers.json"){

     res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('SELECT t.teacher, u.name, u.email FROM redpen.users u inner join redpen.studentsandteachers t on t.student = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?) WHERE u.ID = t.teacher ORDER BY u.name', [cookies["HTTPID"] || ""], function(err, rows) {
    
        if (err) {
          connection.release();
          res.end(JSON.stringify({code:100, message: 'Teachers selection error'}));
          return;
        };

        var teachers = rows;

        connection.query('SELECT w.ID, w.teacher, w.title, w.statement, w.createtime, w.lastupdatetime, (select count(*) from redpen.images i where i.work = w.ID) images,' + 
           ' (select sum(i.score) from redpen.images i where i.work = w.ID and w.statement = \'corrected\') score FROM redpen.works w WHERE w.student = (SELECT s.user FROM redpen.sessions s WHERE s.cookie = ?) ORDER BY w.lastupdatetime DESC', [cookies["HTTPID"] || ""], function(err, rows){
          connection.release();
          if (err) {
            console.log("err", err);
            res.end(JSON.stringify({code:100, message: 'Works selection error'}));
            return;
          };

          var works = rows;
          res.end(JSON.stringify({OK: true, teachers: teachers, works: works}));
        });
      });
    }); 
  } 
  

  else if (parsed.pathname == "/uploadwork.json"){

    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var tmpDir = randomString(7, 10)

    var position = 0;
    var form = new multiparty.Form();

    form.parse(req, function(err, fields, files) {
      console.log("fields", fields);
      console.log("files", files);

      var workname = fields["uploadworkname"];
      var teacher = fields["selectteacher"];

      pool.getConnection(function(err, connection) {
        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
          return;
        };
             
               
        connection.query('INSERT INTO redpen.works (title, student, teacher, statement) ' +
          'SELECT ?, s.user, ?, \'draft\' FROM redpen.sessions s WHERE s.cookie = ?', [workname, teacher, cookies["HTTPID"] || ""], function(err) {

          if (err) {
            connection.release();
            console.log("err", err);
            res.end(JSON.stringify({code:100, message: 'Insert error'}));
            return;
          };

          connection.query('select LAST_INSERT_ID() ID', [], function(err, rows) {
            if (err) {
              connection.release();
              console.log("err", err);
              res.end(JSON.stringify({code:100, message: 'Insert error - ID'}));
              return;
            };

            var workID = rows[0]["ID"];

            var fileids = [];
            for (var key in files) fileids.push(key);

            var iterator = function(i) {

              if (fileids[i]) {
                var file =  files[fileids[i]][0];

                if (file.size) {

                  var p = file.path.split(".");
                  p[p.length - 1] = "jpeg";

                  if (shell.exec('"%ProgramFiles%\\nodejs\\ImageMagic\\convert.exe" "' + file.path + '" "' + p.join(".") + '"').code !== 0) {
                      res.end(JSON.stringify({code:100, message: 'Convert error'}));
                      return;
                  }

                  var converted = [p.join(".")];
                 

                  var stem = p[p.length - 2];
                  for (var j = 0; j<100;j++){
                     p[p.length - 2] = stem + "-" + j;   
                     converted.push(p.join("."));
                  }
                   
                  var filesIterator = function(j){
                     var path = converted[j];
                     if (path) {
                        if (fs.existsSync(path)) {

                           var  img = fs.readFileSync(path); 
                           fs.unlink(path);

                           var dimensions = sizeOf(img);
                             console.log(dimensions.width, dimensions.height);

                             connection.query('INSERT INTO redpen.images (position, work, data, width, height) ' +
                                  'values (?, ?, ?, ?, ?)', [position++, workID, img, dimensions.width, dimensions.height], function(err) {
  
                               if (err) {
                                 connection.release();
                                 console.log("err", err);
                                 res.end(JSON.stringify({code:100, message: 'Insert error - images'}));
                                 return;
                               };

                               filesIterator(j + 1);

                             });
                        }
                        else
                          filesIterator(j + 1);
                     }
                     else {
                       if (fs.existsSync(file.path))
                         fs.unlink(file.path);
                       iterator(i + 1);
                     } 

                  };
                  filesIterator(0);

                }
                else {
                  if (fs.existsSync(file.path)) 
                    fs.unlink(file.path);
                  iterator(i + 1);
                }
              }  
              else {

                connection.query('update redpen.works set statement = \'revising\' where ID = ? and ? <> \'on\' and exists(select * from redpen.images i where i.work = ?) ', [workID, fields["draft"] || 'off', workID], function(err, result) { 
                   if (err) {
                     connection.release();
                     console.log("err", err);
                     res.end(JSON.stringify({code:100, message: 'Update error'}));
                     return;
                   };

                   var returnResult = function(){

                     connection.query('SELECT ID, title, statement, createtime, lastupdatetime, teacher, (select count(*) from redpen.images i where i.work = w.ID) images,' + 
                     ' (select sum(i.score) from redpen.images i where i.work = w.ID) score FROM redpen.works w WHERE ID = ?', [workID], function(err, rows){
                       if (err) {
                         connection.release();
                         console.log("err", err);
                         res.end(JSON.stringify({code:100, message: 'Select error'}));
                         return;
                       };                     
                       var works = rows;
                       var teacherID = rows[0]["teacher"];

                       connection.query('SELECT name, email FROM redpen.users WHERE ID = ?', [teacher], function(err, rows){
                         connection.release();
                         if (err) {
                           console.log("err", err);
                           res.end(JSON.stringify({code:100, message: 'Select error'}));
                           return;
                         };                     
                         res.end(JSON.stringify({OK: true, work: works, teacher: rows}));
                       });
                     });


                   }

                   if (result.affectedRows) {

                     connection.query('SELECT t.name teachername, t.email teacheremail, s.name studentname, s.email studentemail FROM redpen.users t, redpen.users s WHERE t.ID = ? and s.ID = (SELECT c.user FROM redpen.sessions c WHERE c.cookie = ?)', 
                      [teacher, cookies["HTTPID"] || ""], function(err, rows) {
                       //connection.release();
                       if (err) {
                         connection.release();
                         console.log("err", err);
                         res.end(JSON.stringify({code:100, message: 'Insert error'}));
                         return;
                       };
                       transport.sendMail({
                          from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
                          to: rows[0]["teacheremail"],
                          subject: 'Ha rebut un treball nou',
                          html: 'Hola, ' + rows[0]["teachername"] + '! ' + rows[0]["studentname"] + '(' + rows[0]["studentemail"] + ') l\'ha enviat un el treball ' + workname + '.' + '<a href="http://aglaya.pro/redpen">http://aglaya.pro/redpen</a>'
                         }, function(err, info) {
                           if (err) {
                             res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
                             return;
                           }
                           returnResult();
                         }); 
                     });
                   } 
                   else {
                     returnResult();
                   };
                });
              }
            };

            iterator(0);

          }); 

        }); 

      }); 

    }); 
  }

  else if (parsed.pathname == "/newimage.json"){
    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var workID = parsed.query["id"];
    
    var form = new multiparty.Form();

    form.parse(req, function(err, fields, files) {
      console.log("fields", fields);
      console.log("files", files);

      pool.getConnection(function(err, connection) {
        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
          return;
        };

        var fileids = [];
        for (var key in files) fileids.push(key);

        connection.query('SELECT 1 FROM redpen.works WHERE ID = ? and statement = \'draft\'', [workID], function(err, rows) {
                 
          if (err) {
            connection.release();
            console.log("err", err);
            res.end(JSON.stringify({code:100, message: 'Works selection error'}));
            return;
          };
  
          if (!rows || !rows.length) {
            res.end(JSON.stringify({OK: true, readOnly: true}));
            return
          }

          else {
            var iterator = function(i){
              if (fileids[i]) {
                var file =  files[fileids[i]][0];
                if (file.size) {


                  var p = file.path.split(".");
                  p[p.length - 1] = "jpeg";

                  if (shell.exec('"%ProgramFiles%\\nodejs\\ImageMagic\\convert.exe" "' + file.path + '" "' + p.join(".") + '"').code !== 0) {
                      res.end(JSON.stringify({code:100, message: 'Convert error'}));
                      return;
                  }

                  var converted = [p.join(".")];
                 

                  var stem = p[p.length - 2];
                  for (var j = 0; j<100;j++){
                     p[p.length - 2] = stem + "-" + j;   
                     converted.push(p.join("."));
                  }

                  var filesIterator = function(j){
                     var path = converted[j];
                     if (path) {
                        if (fs.existsSync(path)) {

                          var  img = fs.readFileSync(path); 
                          fs.unlink(path);

                          var dimensions = sizeOf(img);


                          connection.query('INSERT INTO redpen.images (position, work, data, width, height) ' +
                            'values ((SELECT MAX(a.position)+1 FROM redpen.images a WHERE a.work = ?)||1, ?, ?, ?, ?)', [workID, workID, img, dimensions.width, dimensions.height], function(err) {
                              if (err) {
                                connection.release();
                                console.log("err", err);
                                res.end(JSON.stringify({code:100, message: 'Insert images error'}));
                                return;
                              };
                              filesIterator(j + 1);
                          });

                        }
                        else
                          filesIterator(j + 1);
                    }
                    else {
                      fs.unlink(file.path);
                      iterator(i + 1);
                    } 
                  };
                  filesIterator(0); 
                }
                else {
                iterator(i + 1);
                };
              }
              else{
                connection.query('SELECT w.title title, w.ID work, w.statement statement, u.name teachername, (select count(*) from redpen.images i where i.work = ?) images,' + 
                    '(select sum(i.score) from redpen.images i where i.work = ?) score FROM redpen.users u inner join redpen.works w on w.ID = ? WHERE u.ID = (SELECT a.teacher FROM redpen.works a WHERE a.ID = ?)', [workID, workID, workID, workID], function(err, rows) {
                  connection.release();
                  if (err) {
                    console.log("err", err);
                    res.end(JSON.stringify({code:100, message: 'Insert images error'}));
                    return;
                  };
                  res.end(JSON.stringify({OK: true, title: rows[0].title, teacher: rows[0].teachername, workID: rows[0].work, statement: rows[0].statement, images: rows[0].images}));
                })
              };
            };

            iterator(0);
          };
        });
      });
    });
  }

 else if (parsed.pathname == "/tostudent.json"){
     res.writeHead(200, {
      'Content-Type': 'image/jpeg'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        console.log(err)
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('UPDATE redpen.works SET statement = \'draft\', lastupdatetime = CURRENT_TIMESTAMP WHERE ID = ? and statement = \'revising\'',  [id], function(err) {
        if (err) {
          connection.release();
          console.log(err)
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };
        connection.query('SELECT t.name teachername, t.email teacheremail, s.name studentname, s.email studentemail, a.title workname, ' +
     ' (select count(*) from redpen.images i where i.work = a.ID) images, (select sum(i.score) from redpen.images i where i.work = a.ID) score FROM redpen.users t, redpen.users s, redpen.works a WHERE t.ID = (SELECT w.teacher FROM redpen.works w WHERE ID = ?) and s.ID = (SELECT c.user FROM redpen.sessions c WHERE c.cookie = ?) and a.ID = ? ', 
          [id, cookies["HTTPID"] || "", id], function(err, rows) {
            connection.release();
            if (err) {
              console.log("err", err);
              res.end(JSON.stringify({code:100, message: 'Insert error'}));
              return;
            };
            transport.sendMail({
              from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
              to: rows[0]["studentemail"],
              subject: 'El professor t\'ha tornat un treball',
              html: 'Hola, ' + rows[0]["studentname"] + '! ' + rows[0]["teachername"] + '(' + rows[0]["teacheremail"] + ') t\'ha tornat el treball ' + rows[0]["workname"] + '.' + '<a href="http://aglaya.pro/redpen">http://aglaya.pro/redpen</a>'
            }, function(err, info) {
                 if (err) {
                   res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
                   return;
                 }
               }); 
        });
        res.end(JSON.stringify({OK: true})); 
      });
    });
  }

   else if (parsed.pathname == "/corrected.json"){
     res.writeHead(200, {
      'Content-Type': 'image/jpeg'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        console.log(err)
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('UPDATE redpen.works SET statement = \'corrected\', lastupdatetime = CURRENT_TIMESTAMP WHERE ID = ? and statement = \'revising\'',  [id], function(err) {
        
        if (err) {
          connection.release();
          console.log(err)
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        connection.query('SELECT w.title title, (select count(*) from redpen.images i where i.work = ?) images, (select u.name from redpen.users u where u.ID = (select w.teacher from redpen.works w where w.id = ?)) name FROM redpen.works w WHERE ID = ?',  [id, id, id], function(err, rows) {  
          connection.release();

          if (err){
          console.log(err)
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
          };
          console.log(rows)
      
          res.end(JSON.stringify({OK: true, work: rows})); 
        });
      });
    });
  }

  else if (parsed.pathname == "/notcorrected.json"){
     res.writeHead(200, {
      'Content-Type': 'image/jpeg'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        console.log(err)
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('UPDATE redpen.works SET statement = \'revising\', lastupdatetime = CURRENT_TIMESTAMP WHERE ID = ? and statement = \'corrected\'',  [id], function(err) {
        if (err) {
          connection.release();
          console.log(err)
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        connection.query('SELECT w.title title, (select count(*) from redpen.images i where i.work = ?) images, (select u.name from redpen.users u where u.ID = (select w.teacher from redpen.works w where w.id = ?)) name FROM redpen.works w WHERE ID = ?',  [id, id, id], function(err, rows) {  
          connection.release();

          if (err){
          console.log(err)
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
          };
          console.log(rows)
      
          res.end(JSON.stringify({OK: true, work: rows})); 
        }); 
      });
    });
  }

  else if (parsed.pathname == "/toteacher.json"){
     res.writeHead(200, {
      'Content-Type': 'image/jpeg'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        console.log(err)
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

        connection.query('select 1 from redpen.images where work = ?',  [id], function(err, rows) {
          if (err) {
            connection.release();
            console.log(err)
            res.end(JSON.stringify({code:100, message: 'Error while performing query2'}));
            return;
          };

        if(rows[0]){     
          connection.query('UPDATE redpen.works SET statement = \'revising\', lastupdatetime = CURRENT_TIMESTAMP WHERE statement = \'draft\' AND ID = ?',  [id], function(err) {
            if (err) {
              connection.release();
              console.log(err)
              res.end(JSON.stringify({code:100, message: 'Error while performing query22'}));
              return;
            };
            connection.query('SELECT t.name teachername, t.email teacheremail, s.name studentname, s.email studentemail, a.title workname, ' + 
              ' (select count(*) from redpen.images i where i.work = a.ID) images, (select sum(i.score) from redpen.images i where i.work = a.ID) score FROM redpen.users t, redpen.users s, redpen.works a WHERE t.ID = (SELECT w.teacher FROM redpen.works w WHERE ID = ?) and s.ID = (SELECT c.user FROM redpen.sessions c WHERE c.cookie = ?) and a.ID = ? ', 
              [id, cookies["HTTPID"] || "", id], function(err, rows) {
                connection.release();
                if (err) {
                  console.log("err", err);
                  res.end(JSON.stringify({code:100, message: 'Insert error'}));
                  return;
                };
                  transport.sendMail({
                  from: 'Red Pen Team <aglaya.pro.redpen@gmail.com>',
                  to: rows[0]["teacheremail"],
                  subject: 'Ha rebut un treball nou',
                  html: 'Hola, ' + rows[0]["teachername"] + '! ' + rows[0]["studentname"] + '(' + rows[0]["studentemail"] + ') l\'ha enviat un el treball ' + rows[0]["workname"] + '.' + '<a href="http://aglaya.pro/redpen">http://aglaya.pro/redpen</a>'
                }, function(err, info) {
                    if (err) {
                      res.end(JSON.stringify({code:100, message: 'Error while sending mail'}));
                      return;
                    }
                  }
                ); 
                res.end(JSON.stringify({OK: true, teachername: rows[0]["teachername"]})); 
            });
          });
        }
        else {
          res.end(JSON.stringify({code:100, message: 'No pots passar al professor un treball buit!'}))
        }
      });
    });
  }

  else if (parsed.pathname == "/deleteimage.json"){
    res.writeHead(200, {
      'Content-Type': 'image/jpeg'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('SELECT 1 FROM redpen.works w WHERE ID = (SELECT i.work FROM redpen.images i WHERE ID = ?)', [id], function(err, rows) {

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };

        if (!rows.length) {
          res.end(JSON.stringify({OK: true, readOnly: true}))
          return;
        }

        else {
          connection.query('DELETE FROM redpen.images WHERE ID = ?', [id], function(err) {
          connection.release();
            if (err) {
              res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
              return;
            };
            res.end(JSON.stringify({OK: true})); 
         });
        };
      });
    });
  }

  else if (parsed.pathname == "/workimage.jpeg"){


    res.writeHead(200, {
      'Content-Type': 'image/jpeg'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('select data from redpen.images where ID = ?',
        [id], function(err, rows) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };
        console.log(rows[0])  ;
        res.end(rows[0].data);
      });
    });


  }

  else if (parsed.pathname == "/workimagemarks.json"){


    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('select u.role role from redpen.users u where u.ID = (select s.user from redpen.sessions s where s.cookie = ?)',
        [cookies["HTTPID"] || ""], function(err, rows) {

        if (err) {
          connection.release();
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };
        console.log("rows", rows[0]["role"])

        if(rows[0]["role"] == "teacher"){
          connection.query('select marks from redpen.images where ID = ?',
            [id], function(err, rows) {

            connection.release();

            if (err) {
              res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
              return;
            };
            console.log(rows[0])  ;
            res.end(JSON.stringify({OK: true, data: rows[0].marks}));
          });
        };
        if(rows[0]["role"] == "student"){
          
          connection.query('select i.marks, i.work from redpen.images i where i.ID = ? and (select w.statement from redpen.works w where w.ID = i.work) = \'corrected\'',
            [id], function(err, rows) {

            connection.release();
            if (err) {
              res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
              return;
            };
            if(rows[0]) res.end(JSON.stringify({OK: true, data: rows[0].marks}))
            else res.end(JSON.stringify({OK: true}))
          });
        };
      })
    });
  }

  else if (parsed.pathname == "/workimageedit.json"){


    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });


    var form = new multiparty.Form();

    form.parse(req, function(err, fields, files) {
  
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error editing marks.'}));
        return;
      };

      var id = fields["id"][0];
      var marks = fields["marks"][0];
      var score = fields["score"][0] || null;

      pool.getConnection(function(err, connection) {
        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
          return;
        };

        connection.query('update redpen.images set marks = ?, score = ? where ID = ?',
          [marks, score, id], function(err) {
          if (err) {
            connection.release();
            res.end(JSON.stringify({code:100, message: 'Error while performing query1'}));
            return;
          };

          connection.query('UPDATE redpen.works w SET w.lastupdatetime = CURRENT_TIMESTAMP WHERE w.ID = (SELECT i.work FROM redpen.images i WHERE ID = ?)', [id], function(err){

             if (err) {
                connection.release();
                console.log(err);
                res.end(JSON.stringify({code:100, message: 'Error while performing query11'}));
                return;
              }; 

              connection.query('SELECT i.work work, (select sum(ii.score) from redpen.images ii where ii.work = i.work) score FROM redpen.images i WHERE ID = ?',
                [id], function(err, rows) {

                connection.release();

                if (err) {
                  res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
                  console.log(err);
                  return;
                };

                res.end(JSON.stringify({OK: true, work:rows[0]["work"], score: rows[0]["score"]}));
              });
          });
        });
      });


    });

  }


  else if (parsed.pathname == "/workimages.json"){


    res.writeHead(200, {
      'Content-Type': 'text/plain; charset=UTF-8'
    });

    var id = parsed.query["id"];

    pool.getConnection(function(err, connection) {
      if (err) {
        res.end(JSON.stringify({code:100, message: 'Error in connection database'}));
        return;
      };

      connection.query('select ID, width, height  from redpen.images where work = ? order by position',
        [id], function(err, rows) {

        connection.release();

        if (err) {
          res.end(JSON.stringify({code:100, message: 'Error while performing query'}));
          return;
        };
        res.end(JSON.stringify({OK: true, images: rows}));
      });
    });


  }

  else {

    res.writeHead(404);
    res.end();
  };
    



});

server.listen(2002, "127.0.0.1", function() {
  console.log('Server started http://127.0.0.1:2002/');
});
