﻿var worksItems = {
  identifier: "ID",
  items: []
};

var teacherWorksItems = {
  identifier: "ID",
  items: []
};

var noBlur = false;

function formatTimestamp(data, rowIndex) {
  var d = dojo.date.stamp.fromISOString(data);
  if (d) return dojo.date.locale.format(d, {
    datePattern: "dd.MM.yyyy",
    timePattern: 'HH:mm'
  });
};

function formatFloat(data, rowIndex){
  if (data) {
    return  dojo.number.format(dojo.number.round(data, 2), {places:2});
  }
  else 
    return "";
};

function toStudent(id) {
  if (!confirm("De veritat vol tornar aquest treball?")) return;
  dojo.xhrGet({
    url: "/redpendata/tostudent.json",
    handleAs: "json",
    content: {
      id: id
    },
    load: function(response) {
      if (!response.OK) {
        handleError(response);
      }
      else {
        teacherWorksModel.fetchItemByIdentity({
          identity: id,
          onItem: function(item) {
            console.log(item);
            grid.selection.deselectAll();
            teacherWorksStore.deleteItem(item);
          }
        })
      }
    },
    error: handleError
  });
};

function notCorrected(id) {
  if (!confirm("De veritat vol tornar a corregir aquest treball?")) return;
  dojo.xhrGet({
    url: "/redpendata/notcorrected.json",
    handleAs: "json",
    content: {
      id: id
    },
    load: function(response) {
      if (!response.OK) {
        handleError(response);
      }
      else {
        console.log(response);
        teacherWorksModel.fetchItemByIdentity({
          identity: id,
          onItem: function(item) {
            console.log(item);
            grid.selection.deselectAll();
            teacherWorksStore.setValue(item, "statement", id + ";revisant");
            teacherWorksStore.setValue(item, "title", "<a href=\"#\" onclick=\"showImage('" + jsescape(response.work[0].title) + "', '" + response.work[0].name + "', " + id + ", null, false, false)\">" + response.work[0].title + "</a>");
            teacherWorksStore.setValue(item, "images", "<a href=\"#\" onclick=\"showImages('" + jsescape(response.work[0].title) + "', '" + response.work[0].name + "', " + id + ", this, 'corrected', false, false)\">" + response.work[0].images + "</a>");
          }
        });
      };
      error: handleError
    }
  });
};

function formatStatementTeacher(data, rowIndex) {

  if (data) {
    var ID = data.split(";")[0];
    data = data.split(";")[1];

    if (data == "revisant") {
      var holder = dojo.toDom("<span>revisant </span>");

      var b = new dijit.form.Button({
        label: "<span style=\"font-size:80%\">Tornar a estudiant</span>",
        onClick: "toStudent('" + ID + "')"
      });
      b._destroyOnRemove = true;

       var bb = new dijit.form.Button({
        label: "<span style=\"font-size:80%\">Corregit</span>",
        onClick: "corrected('" + ID + "')"
      });
      bb._destroyOnRemove = true;

      b.placeAt(holder);
      bb.placeAt(holder);
      return holder.innerHTML;
    }

    else if (data == "corregit") {
      var holder = dojo.toDom("<span>corregit </span>");

      var b = new dijit.form.Button({
        label: "<span style=\"font-size:80%\">Tornar a corregir</span>",
        onClick: "notCorrected('" + ID + "')"
      });
      b._destroyOnRemove = true;

      b.placeAt(holder);
      return holder.innerHTML;
    }
    else console.log(data);
  };
};

function corrected(work){
  if (!confirm("Vol passar aquest treball a corregit?")) return;
  dojo.xhrGet({
    url: "/redpendata/corrected.json",
    handleAs: "json",
    content: {
      id: work
    },
    load: function(response) {
      if (!response.OK) {
        handleError(response);
      }
      else {
        console.log(response);
        teacherWorksModel.fetchItemByIdentity({
          identity: work,
          onItem: function(item) {
            console.log(item);
            grid.selection.deselectAll();
            teacherWorksStore.setValue(item, "statement", work + ";corregit");
            teacherWorksStore.setValue(item, "title", "<a href=\"#\" onclick=\"showImage('" + jsescape(response.work[0].title) + "', '" + response.work[0].name + "', " + work + ", null, true, false)\">" + response.work[0].title + "</a>");
            teacherWorksStore.setValue(item, "images", "<a href=\"#\" onclick=\"showImages('" + jsescape(response.work[0].title) + "', '" + response.work[0].name + "', " + work + ", this, 'corrected', true, false)\">" + response.work[0].images + "</a>");
          }
        })
      }
    },
    error: handleError
  });


};


function formatStatement(data, rowIndex) {

  if (data) {
    var ID = data.split(";")[0];
    var title = data.split(";")[2];
    data = data.split(";")[1];

    if (data == "corregit") {
      return ("<span>corregit</span>");
    }

    else if (data == "revisant") {
      return ("<span>revisant</span>");
    }
    else if (data == "esborrany") {
      var holder = dojo.toDom("<span>esborrany </span>");

      var b = new dijit.form.Button({
        label: "<span style=\"font-size:80%\">Passar al prosessor</span>",
        onClick: "onCheck('" + ID + "', '" + title + "')"
      });
      b._destroyOnRemove = true;

      var bb = new dijit.form.Button({
        label: "<span style='font-size:80%'>Suprimir</span>",
        onClick: "deleteWork('" + ID + "')"
      });
      bb._destroyOnRemove = true;

      b.placeAt(holder);
      bb.placeAt(holder);
      return holder.innerHTML;
    }
  }
};

function deleteWork(id) {
  if (!confirm("Estàs segur que vols suprimir aquest treball?")) return;
  dojo.xhrGet({
    url: "/redpendata/deletework.json",
    handleAs: "json",
    content: {
      id: id
    },
    load: function(response) {
      if (!response.OK) {
        handleError(response);
      }
      else {
        worksModel.fetchItemByIdentity({
          identity: id,
          onItem: function(item) {
            console.log(item);
            grid.selection.deselectAll();
            worksStore.deleteItem(item);
          }
        })
      }
    },
    error: handleError
  });
};

function onCheck(id, title) {

  if (!confirm("Estàs segur que vols enviar aqiest treball a revisar? No podràs tornar a canviar-ne!")) return;
  dojo.xhrGet({
    url: "/redpendata/toteacher.json",
    handleAs: "json",
    content: {
      id: id
    },
    load: function(response) {
      if (!response.OK) {
        handleError(response);
      }
      else {
        worksModel.fetchItemByIdentity({
          identity: id,
          onItem: function(item) {
            console.log(item);
            grid.selection.deselectAll();
            worksStore.setValue(item, "statement", id + ";revisant");
            worksStore.setValue(item, "title", "<a href=\"#\" onclick=\"showImages('" + jsescape(title) + "', '" + response.teachername + "', " + id + ", this, " + "'revising'" + ", true, true)\">" + title + "</a>");
          }
        })
      }
    },
    error: handleError
  });
};

function handleError(err) {
  var msg;
  if (dojo.isObject(err)) msg = err.message || err.toString();
  else msg = err;
  msg = msg || "Unknown error";
  alert(msg);
};

function loginEditChange() {
  dijit.byId("loginButton").attr("disabled", (!dijit.byId("loginemail").validate()) || (!dijit.byId("loginpassword").validate()));
};

function login() {
  var node = dijit.byId("workSpacePane").domNode; 	 

  dojo.fadeOut({
    node: node,
    duration: 100,
    onEnd: function(){


  dojo.xhrGet({
    url: "/redpendata/login.json",
    handleAs: "json",
    content: {
      email: dijit.byId("loginemail").attr("value"),
      password: dijit.byId("loginpassword").attr("value")
    },
    load: function(response) {
      console.log(response);
      if (response.OK) {
        dojo.byId("registration").style.display = "";
        logged(response);
      }
      else {
        dojo.fadeIn({
          node: node,
          onEnd: function(){
            handleError(response);
          },
          duration: 100
        }).play();
      }			
    },
    error: function(){
      dojo.fadeIn({
        node: node,
        duration: 100,
        onEnd: function(){
          handleError();
        }
      }).play();
    }		  
  });




    }
 }).play();

};


function registerEditChange() {
  dijit.byId("invitator").attr("disabled", dijit.byId("role").attr("value") == "teacher");
  if (dijit.byId("invitator").attr("disabled")) dijit.byId("invitator").attr("value", "");
  dijit.byId("registerButton").attr("disabled",   (!dijit.byId("invitator").validate()) || (!dijit.byId("email").validate()) || (!dijit.byId("name").validate()) || (!dijit.byId("role").validate()));
  
};

function register() {

  dojo.xhrGet({
    url: "/redpendata/register.json",
    handleAs: "json",
    content: {
      email: dijit.byId("email").attr("value"),
      name: dijit.byId("name").attr("value"),
      role: dijit.byId("role").attr("value"),
	  invitator: dijit.byId("invitator").attr("value") || ""
    },
    load: function(response) {
      if (response.OK) alert("La contrasenya ha sigut enviada al seu correu electrònic. Comprova-lo i ens veurem una altra vegada.")
      else handleError(response);

    },
    error: handleError
  });
};

function restoreEditChange() {
  dijit.byId("restoreButton").attr("disabled", !dijit.byId("restorepwdemail").validate());
};

function restore() {

  dojo.xhrGet({
    url: "/redpendata/restore.json",
    handleAs: "json",
    content: {
      email: dijit.byId("restorepwdemail").attr("value")
    },
    load: function(response) {
      if (response.OK) alert("La contrasenya ha sigut enviada al seu correu electrònic. Comprova-lo i ens veurem una altra vegada")
      else handleError(response);
    },
    error: handleError
  });
};

function classnameEditChange() {
  dijit.byId("createButton").attr("disabled", !dijit.byId("classname").validate());
};

function createClass() {
  var classname = dijit.byId("classname").attr("value");
  dojo.xhrGet({
    url: "/redpendata/createclass.json",
    handleAs: "json",
    content: {
      classname: classname
    },
    load: function(response) {
      console.log("createClass", response);
      if (response.OK) {
        dijit.byId("classname").attr("value", "");
        dijit.byId("createClassPane").attr("open", false);
        var node = dojo.place("<div class=\"dndContainerTile\">" + "<div dojoType=\"dijit.InlineEditBox\" style=\"width:100%;height:20px;color:#F68620;font-size:150%;font-weight:bold;white-space:nowrap\" " + "oldValue=\"" + classname + "\"" + "onChange=\"classNameChanged(this, '" + response.ID + "')\" > " + classname + " </div>" + "<div class=\"classDndContainer\" dojoType=\"classDndContainer\" classID=\"" + response.ID + "\"></div>", dojo.byId("classesContainerPane"), "last");
        node.scrollIntoView();
        dojo.parser.parse(node);
      }
      else handleError(response);
    },
    error: handleError
  });
};

var noClassDndContainer;

function studentsearch() {
  var emails = dojo.filter(dojo.map(dijit.byId("studentsearch").attr("value").split("\n"), function(s) {
    return dojo.trim(s);
  }), function(s) {
    return dojo.trim(s);
  }).join(";");
  dojo.xhrGet({
    url: "/redpendata/studentsearch.json",
    handleAs: "json",
    content: {
      emails: emails
    },
    load: function(response) {
      console.log("studentsearch", response);
      if (response.OK) {
        dijit.byId("studentsearch").attr("value", "");
        dijit.byId("studentsearchPane").attr("open", false);
        var nodes = [];
        dojo.forEach(response.students, function(student) {
          var node = dojo.place(makeStudentDndNode(student.ID, student.name, student.email), dojo.body(), "last");
          nodes.push(node);
        });
        noClassDndContainer.insertNodes(true, nodes, true, noClassDndContainer.node.firstChild);

        if (response.added !== 0) {
          alert("Hi ha " + response.added + " alumne(s) que ja és(són) afegit(s)! Comproveu-lo(s) a les seus llistes!")
        };

        if (response.notfound.length) {
          dijit.byId("studentsearchPane").attr("open", true);
          dijit.byId("studentsearch").attr("value", response.notfound.join("\n"));
          alert("Hi ha " + response.notfound.length + " e-mail(s) que no existeix(en). Comproveu-lo(s) i intenteu l'altra vegada!");
        };
      }
      else handleError(response);
    },
    error: handleError
  });
};

function deleteclass() {
  if (!confirm("Estàs segur de que vols suprimir aquest treball?")) return;

  dojo.xhrGet({
    url: "/redpendata/deleteclass.json",
    handleAs: "json",
    content: {
      classname: dijit.byId("deleteclassname").attr("value")
    },
    load: function(response) {
      console.log("deleteclass", response);
      if (!response.OK) {
        handleError(response);
      }
      else {
        work
      }
    },
    error: handleError
  });
};

function addinclass(student, classnode) {
  dojo.xhrGet({
    url: "/redpendata/addinclass.json",
    handleAs: "json",
    content: {
      student: student[0]["id"],
      classname: classnode.id
    },
    load: function(response) {
      console.log("addinclass", response);
      if (response.OK) {} else handleError(response);
    },
    error: handleError
  });
}


function classesiestudiantsContainterLayout(duration) {
  setTimeout(function() {
    dijit.byId("classesiestudiantsContainter").resize();
  }, duration + 10);
};

function uploadworkContainterLayout(duration) {

  dijit.byId("uploadworkPane").domNode.style.height = "";

  setTimeout(function() {
    dijit.byId("gridspage").resize();
  }, duration + 10);
};

function studentsearchChange() {
  classesiestudiantsContainterLayout(0);
  dijit.byId("studentsearchButton").attr("disabled", !dijit.byId("studentsearch").attr("value"));

};

function profileChanged() {


  dojo.xhrGet({
    url: "/redpendata/changeprofile.json",
    handleAs: "json",
    content: {
      name: dijit.byId("myNameEdit").attr("value"),
      email: dijit.byId("myEmailEdit").attr("value")
    },
    load: function(response) {
      if (!response.OK) handleError(response);
    },
    error: handleError
  });

};


function classNameChanged(widget, classID) {

  console.log(widget);

  if (widget.attr("value")) dojo.xhrGet({
    url: "/redpendata/renameclass.json",
    handleAs: "json",
    content: {
      "class": classID,
      name: widget.attr("value")
    },
    load: function(response) {
      if (response.OK) {

        widget.domNode.setAttribute("oldValue", widget.attr("value"))
      }
      else handleError(response);
    },
    error: handleError
  });

  else {
    if (!confirm("De veritat vol suprimir aquesta classe?")) {
      widget.cancel(false);
      widget.attr("value", widget.domNode.getAttribute("oldValue"));
      return;
    }

    dojo.xhrGet({
      url: "/redpendata/deleteclass.json",
      handleAs: "json",
      content: {
        "ID": classID
      },
      load: function(response) {
        if (response.OK) {
          var parent = widget.domNode.parentNode;
          widget.destroyRecursive();
          parent.parentNode.removeChild(parent);
        }
        else handleError(response);
      },
      error: handleError
    });
  }
};


function addnotinclass(nodes) {

  console.log("nodes", nodes);

  dojo.forEach(nodes, function(node) {
    dojo.xhrGet({
      url: "/redpendata/addinclass.json",
      handleAs: "json",
      content: {
        student: node.getAttribute("studentid"),
        "class": null
      },
      load: function(response) {
        if (!response.OK) handleError(response);
      },
      error: handleError
    });

  });


};

function deletestudent(nodes) {
  if (!confirm("De veritat vol suprimir aquest(s) alumne(s)?")) {
    var returnNode = [];
    dojo.forEach(nodes, function(node) {
      returnNode.push(node);     
    });
    noClassDndContainer.insertNodes(true, returnNode, true, noClassDndContainer.node.firstChild);
    return;
  };
  dojo.forEach(nodes, function(node) {
    dojo.xhrGet({
      url: "/redpendata/deletelink.json",
      handleAs: "json",
      content: {
        student: node.getAttribute("studentid")
      },
      load: function(response) {
        if (!response.OK) handleError(response);
      },
      error: handleError
    });

    node.parentNode.removeChild(node);
  });

}



function showItem(grid, item){
  var index = grid.getItemIndex(item)
  var top = grid.scroller.findScrollTop(index);
  var _alreadySet = (grid.views.setScrollTop(top) == top)
  if (_alreadySet) {
    grid.focus.focusGrid();
    grid.focus.setFocusIndex(index, 0);
  }
}


function uploadwork() {

  dojo.io.iframe.send({

    method: "POST",
    form: dojo.byId("uploadworkform"),
    handleAs: "html",

    handle: function(htmlResponse, ioArgs) {
      var response = dojo.fromJson(htmlResponse.body.textContent || htmlResponse.body.innerText);
      console.log("handle", response, ioArgs)
      if (!response.OK) handleError(response)
      else {
        console.log(response);

        worksModel.fetchItemByIdentity({
          identity: "t" + response.work[0]["teacher"],
          onItem: function(item) {
            console.log(item);
            if (item) { 
              worksModel.newItem({
                ID: response.work[0]["ID"],
                images: "<a href=\"#\" onclick=\"showImages('" + jsescape(response.work[0].title) + "', '" + response.teacher[0].name + "', " + response.work[0].ID + ", this, '" + response.work[0].statement + "', true, true)\">" + response.work[0].images + "</a>",
                title: "<a href=\"#\" onclick=\"showImage('" + jsescape(response.work[0].title) + "', '" + response.teacher[0].name + "', " + response.work[0].ID + ", null, true, true)\">" + response.work[0].title + "</a>",
                statement: response.work[0]["ID"] + ";" + translate(response.work[0]["statement"]),
                createtime: response.work[0]["createtime"],
                lastupdatetime: response.work[0]["lastupdatetime"],
                score: response.work[0]["score"]
              }, item, 0);
  
              showItem(grid, item);
               
//              grid.focus.focusGrid();
//              grid.focus.setFocusIndex(item, 0);
//              grid.focus.focusGrid();
//              grid.selection.select(item);
              worksModel.fetchItemByIdentity({
                identity: response.work[0]["ID"],
                onItem: function(item){
                        //showItem(grid, item) ;
//                  console.log("item", item);
                  //grid.selection.select(item);
//                  grid.focus.focusGrid();
//                 grid.selection.select(item);
  //                grid.selection.setSelected(item, true);
/*                  var top = grid.scroller.findScrollTop(item);
                  var _alreadySet = (grid.views.setScrollTop(top) == top)
                  if (_alreadySet) {
                    grid.focus.focusGrid();
                    grid.focus.setFocusIndex(item, 0);
                  }*/
                }
              });
            }
            else {
              worksModel.newItem({
                ID: 't' + response.work[0]["teacher"],
                title: "<span style=\"margin-left:5px;font-weight:bold;\">Professor: " + response.teacher[0].name + " (<a href=\"mailto:" + response.teacher[0].email + "\">" + response.teacher[0].email + "</a>)</span>",
                root: true,
                children: []
              }, null, 0);

              worksModel.fetchItemByIdentity({
                identity: "t" + response.work[0]["teacher"],
                onItem: function(item) {
                  console.log(item);
                  showItem(grid, item);

                  worksModel.newItem({
                    ID: response.work[0]["ID"],
                    images: "<a href=\"#\" onclick=\"showImages('" + jsescape(response.work[0].title) + "', '" + response.teacher[0].name + "', " + response.work[0].ID + ", this, '" + response.work[0].statement + "', true, true)\">" + response.work[0].images + "</a>",
                    title: "<a href=\"#\" onclick=\"showImage('" + jsescape(response.work[0].title) + "', '" + response.teacher[0].name + "', " + response.work[0].ID + ", null, true, true)\">" + response.work[0].title + "</a>",
                    statement: response.work[0]["ID"] + ";" + translate(response.work[0]["statement"]),
                    createtime: response.work[0]["createtime"],
                    lastupdatetime: response.work[0]["lastupdatetime"],
                    score: response.work[0]["score"]
                  }, item);
                  //showItem(grid, item);
                }
              });
            }
          }
        })
      }
    }
  });

  dijit.byId("draft").attr("checked", false);
  dijit.byId("uploadworkPane").attr("open", false);
  dojo.byId("uploadworkform").reset();
};


function uploadworknameEditChange() {
  dijit.byId("uploadworkButton").attr("disabled", !dijit.byId("uploadworkname").attr("value"));
};


function makeStudentDndNode(id, name, email) {

  return "<div class=\"dojoDndItem\" studentid=\"" + id + "\" >" + "<span style=\"font-weight:bold\">" + name + "</span> (<a href=\"mailto:" + email + "\">" + email + "</a>)" + "</div>";

}

function translate(word) {
  switch (word) {
  case "revising":
    return ("revisant");
    break;
  case "draft":
    return ("esborrany");
    break;
  case "corrected":
    return ("corregit");
    break;
  };
};

function getObject(arr, prop, value) {
  for (var i = 0; i < arr.length; i++) {
    if (arr[i][prop] == value) return arr[i];
  };
};

function logged(data) {
  var node = dojo.byId("registration");
  node.parentNode.removeChild(node);

  if (data.role == "teacher") {

    dojo.byId("loadingMessage").style.display = "";

    dojo.place(dojo.cache("redpen", "professor.html"), dijit.byId("workSpacePane").containerNode, "beforeend");

    dojo.byId("myNameEdit").innerHTML = data.name;
    dojo.byId("myEmailEdit").innerHTML = data.email;

    dojo.xhrGet({
      url: "/redpendata/mylist.json",
      handleAs: "json",
      content: {},
      load: function(response) {
        console.log("mylist", response);
        if (response.OK) {
          if (response.students.length == 0) {
            dojo.byId("studentsearchPane").setAttribute("open", "true");
            dojo.byId("classesiestudiantsPane").setAttribute("selected", "true");
          };
          if (response.classes.length == 0) {
            dojo.byId("createClassPane").setAttribute("open", "true");
          };

          dojo.forEach(response.classes, function(classInfo) {
            var content = [];
            dojo.forEach(response.students, function(studentInfo) {
              if (studentInfo.teacherclass == classInfo.ID) content.push(makeStudentDndNode(studentInfo.student, studentInfo.name, studentInfo.email));
            });
            dojo.place("<div class=\"dndContainerTile\">" + "<div dojoType=\"dijit.InlineEditBox\" style=\"width:100%;height:20px;color:#F68620;font-size:150%;font-weight:bold;white-space:nowrap\" " + "oldValue=\"" + classInfo.className + "\"" + "onChange=\"classNameChanged(this, '" + classInfo.ID + "')\" > " + classInfo.className + " </div>" + "<div class=\"classDndContainer\" dojoType=\"classDndContainer\" classID=\"" + classInfo.ID + "\">" + content.join("") + "</div></div>", dojo.byId("classesContainerPane"), "last");
          });

          dojo.forEach(response.students, function(studentInfo) {
            if (!studentInfo.teacherclass) dojo.place(makeStudentDndNode(studentInfo.student, studentInfo.name, studentInfo.email), dojo.byId("notInClassContainer"), "last");
          });

          var items = [];
          var children = {};
          children["noClass"] = [];

          dojo.forEach(response.works, function(work) {
            var studentObj = getObject(response.students, "student", work.student);
               
            if (!studentObj) return;

            items.push({
              ID: work.ID,
              student: studentObj.name + " (<a href=\"mailto:" + studentObj.email + "\">" + studentObj.email + "</a>)",
              title: "<a href=\"#\" onclick=\"showImage('" + jsescape(work.title) + "', '" + studentObj.name + "', " + work.ID + ", null, " + (work.statement=="corrected"?"true":"false") + ", false)\">" + work.title + "</a>",
              images: "<a href=\"#\" onclick=\"showImages('" + jsescape(work.title) + "', '" + studentObj.name + "', " + work.ID + ", this, '" +  work.statement + "', " + (work.statement=="corrected"?"true":"false") + ", false)\">" + work.images + "</a>",
              statement: work.ID + ";" + translate(work.statement),
              createtime: work.createtime,
              lastupdatetime: work.lastupdatetime,
              score: work.score
            });
            if ((studentObj.teacherclass !== null) && (response.classes.length)) {
              var classObj = getObject(response.classes, "ID", studentObj.teacherclass);
              if (!children[classObj.ID]) {
                children[classObj.ID] = [];
              };
              children[classObj.ID].push({
                _reference: work.ID
              });
            }
            else children["noClass"].push({
              _reference: work.ID
            })
//}       
          });

          dojo.forEach(response.classes, function(classInfo) {
            if (children[classInfo.ID]) {
              items.push({
                ID: "c" + classInfo.ID,
                student: "<span style=\"margin-left:5px;font-weight:bold;\">Classe: " + classInfo.className + "</span>",
                root: true,
                children: children[classInfo.ID]
              });
            };
          });

          if (children["noClass"].length) {
            items.push({
              ID: "c0",
              student: "<span style=\"margin-left:5px;font-weight:bold;\">Sense classe</span>",
              root: true,
              children: children["noClass"]
            });
          }

          teacherWorksItems.items = items;

          dojo.parser.parse(dijit.byId("workSpacePane").containerNode)[0].resize();
          dojo.byId("loadingMessage").style.display = "none";
          dojo.fadeIn({
            node: dijit.byId("workSpacePane").domNode,
            duration: 700
          }).play();
        }
        else handleError(response);
      },
      error: handleError
    });
  }
  else if (data.role = "student") {

    dojo.byId("loadingMessage").style.display = "";

    dojo.place(dojo.cache("redpen", "estudiant.html"), dijit.byId("workSpacePane").containerNode, "beforeend");
    dojo.byId("myNameEdit").innerHTML = data.name;
    dojo.byId("myEmailEdit").innerHTML = data.email;

    dojo.xhrGet({
      url: "/redpendata/myteachers.json",
      handleAs: "json",
      content: {},
      load: function(response) {
        if (!response.OK) handleError(response)
        else {
          console.log(response);

          if (!response.teachers.length) {
            dojo.place("<div style=\"font-size:300%; color:#243C5F\"> Oops... </div><div style=\"font-size:200%; color:#243C5F\">Sembla que no ets agregat per cap professor.</div><div style=\"font-size:200%; color:#243C5F\">Contacta amb els teus professors i torna a comprovar-ho.</div>", dojo.byId("worksContainer"), "only");
          };

          dojo.forEach(response.teachers, function(teacherInfo) {
            dojo.place("<option value=\"" + teacherInfo.teacher + "\">" + teacherInfo.name + " (" + teacherInfo.email + ")</option>", dojo.byId("selectteacher"), "last");
          })

          if (!response.works.length && response.teachers.length) {
            dojo.byId("uploadworkPane").setAttribute("open", "true");
          }
          else {

            var items = [];
            var children = {};

            dojo.forEach(response.works, function(work) {

              var teacher = getObject(response.teachers, "teacher", work.teacher);

              if (work.statement == "draft") {
                items.push({
                  ID: work.ID,
                  images: "<a href=\"#\" onclick=\"showImages('" + jsescape(work.title) + "', '" + teacher.name + "', " + work.ID + ", this, '" + work.statement +  "', true, true)\">" + work.images + "</a>",
                  title: "<a href=\"#\" onclick=\"showImage('" + jsescape(work.title) + "', '" + teacher.name + "', " + work.ID + ", null, true, true)\">" + work.title + "</a>",
                  statement: work.ID + ";" + translate(work.statement) + ";" + work.title,
                  createtime: work.createtime,
                  lastupdatetime: work.lastupdatetime,
                  score: work.score
                });
              }
              else {
                if (!teacher){
                  items.push({
                  ID: work.ID,
                  images: "<a href=\"#\" onclick=\"showImages('" + jsescape(work.title) + "', '" + "" + "', " + work.ID + ", this, '" +  work.statement + "', true, true)\">" + work.images + "</a>",
                  title: "<a href=\"#\" onclick=\"showImage('" + jsescape(work.title) + "', '" + "" + "', " + work.ID + ", null, true, true)\">" + work.title + "</a>",
                  statement: work.ID + ";" + translate(work.statement),
                  createtime: work.createtime,
                  lastupdatetime: work.lastupdatetime,
                  score: work.score
                  }); 
                }
                else {
                  items.push({
                    ID: work.ID,
                    images: "<a href=\"#\" onclick=\"showImages('" + jsescape(work.title) + "', '" + teacher.name + "', " + work.ID + ", this, '" +  work.statement + "', true, true)\">" + work.images + "</a>",
                    title: "<a href=\"#\" onclick=\"showImage('" + jsescape(work.title) + "', '" + teacher.name + "', " + work.ID + ", null, true, true)\">" + work.title + "</a>",
                    statement: work.ID + ";" + translate(work.statement),
                    createtime: work.createtime,
                    lastupdatetime: work.lastupdatetime,
                    score: work.score
                  });
                };
              }
              if (!children[work.teacher]) children[work.teacher] = [];
              children[work.teacher].push({
                _reference: work.ID
              });
            });

            dojo.forEach(response.teachers, function(teacherInfo) {
              if (children[teacherInfo.teacher]) {
                items.push({
                  ID: "t" + teacherInfo.teacher,
                  title: "<span style=\"margin-left:5px;font-weight:bold;\">Professor: " + teacherInfo.name + " (<a href=\"mailto:" + teacherInfo.email + "\">" + teacherInfo.email + "</a>)</span>",
                  root: true,
                  children: children[teacherInfo.teacher]
                });
              }
            });

            worksItems.items = items;
          };

          dojo.parser.parse(dijit.byId("workSpacePane").containerNode)[0].resize();
          dojo.byId("loadingMessage").style.display = "none";
          dojo.fadeIn({
            node: dijit.byId("workSpacePane").domNode,
            duration: 700
          }).play();
        }
      },
      error: handleError
    });
  };
};

function logout() {
  dojo.cookie("HTTPID", "", {
    path: "/"
  });
  window.open(document.location.pathname, "_self");
};

function deletepage(id, workID) {
  noBlur = true;
  if (!confirm("Estàs segur que vols suprimir aquesta pàgina?")) return;
  dojo.xhrGet({
    url: "/redpendata/deleteimage.json",
    handleAs: "json",
    content: {
      id: id
    },
    load: function(response) {
      if (!response.OK) handleError(response)
      else {
        if (response.resdOnly == true) alert("Aquest treball no és un esborrany, no pots canviar-ho!")
        else dojo.destroy(dojo.byId("image" + id));
      };
    }
  });
};

var dialog;

function uploadpage() {

  dojo.io.iframe.send({

    method: "POST",
    form: dojo.byId("addpageform"),
    handleAs: "html",

    handle: function(htmlResponse, ioArgs) {
      var response = dojo.fromJson(htmlResponse.body.textContent || htmlResponse.body.innerText);
      console.log("handle", response, ioArgs)
      if (!response.OK) handleError(response)
      else {
        dialog.hide().then(function() {
          dialog.destroyRecursive();
          dialog = null;
        });
         var i = "<a href=\"#\" onclick=\"showImages('" + jsescape(response.title) + "', '" + response.teacher + "', " + response.workID + ", this, '" + response.statement + "', true, true)\">" + response.images + "</a>";
         console.log(i);
         worksModel.fetchItemByIdentity({
          identity: response.workID,
          onItem: function(item) {
            console.log(item);
            grid.selection.deselectAll();
            worksStore.setValue(item, "images", i);
          }
        });
        if (response.readOnly == true) alert("Aquest treball no és un esborrany, no pots canviar-ho!");
      };
    }
  });
};

function addpage(work) {
  noBlur = true;
  var content = dojo.cache("redpen", "newPageDialog.html");
  content = content.split("$work$").join(work);
  dialog = new dijit.Dialog({
    title: "<span style=\"font-size:150%;text-align:center\">afegir pàgines",
    content: content
  });
  dialog.show();
};

function jsescape(escapeString) {
  return (escapeString || "").replace(/[\\]/g, '\\\\')
    .replace(/[\"]/g, '\\\"')
    .replace(/[\/]/g, '\\/')
    .replace(/[\b]/g, '\\b')
    .replace(/[\f]/g, '\\f')
    .replace(/[\n]/g, '\\n')
    .replace(/[\r]/g, '\\r')
    .replace(/[\t]/g, '\\t');
}

function showImages(workTitle, name, workID, node, statement, readOnly, selectNeeded) {

console.log(readOnly);
  
  dojo.xhrGet({
    url: "/redpendata/workimages.json",
    handleAs: "json",
    content: {
      id: workID
    },
    load: function(response) {
      if (!response.OK) handleError(response)
      else {

        console.log(response.images);

        var w = dojo.coords(document.body).w * 0.64;;

        var thumbs;

        if (statement == "draft") {
          thumbs = dojo.map(response.images, function(image) {
            return "<div id=\"image" + image.ID + "\" align=\"center\" class=\"thumbTile\"><a href=\"#\" onclick=\"showImage('" + jsescape(workTitle) + "', '" + name + "', " + workID + ", " + image.ID + ", true, true)\"><img style=\"border: 4px dotted #243C5F; height:160\" src=\"/redpendata/workimage.jpeg?id=" + image.ID + "\"/></a><div><button dojoType=\"dijit/form/Button\" onClick=\"deletepage(" + image.ID + "," + workID + ")\">suprimir</button></div></div>"
          });
          thumbs.push("<div align=\"center\" class=\"thumbTile\"><div><button dojoType=\"dijit/form/Button\" onClick=\"addpage(" + workID + ")\"><span style=\"border:1px solid black;width:160px;font-size:144px\">+</span></button></div></div>");
        }
        else {
          thumbs = dojo.map(response.images, function(image) {
            return "<div id=\"image" + image.ID + "\" align=\"center\" class=\"thumbTile\"><a href=\"#\"onclick=\"showImage('" + jsescape(workTitle) + "', '" + name + "', " + workID + ", " + image.ID + ", " + readOnly + ", " + selectNeeded + ")\"><img style=\"border: 4px dotted #243C5F; height:160\" src=\"/redpendata/workimage.jpeg?id=" + image.ID + "\"/></a></div>"
          });
          thumbs.push("<div align=\"center\" class=\"thumbTile\"></div>");
        };

        setTimeout(function() {
          dijit.popup.open({
            popup: new dijit.TooltipDialog({
              content: "<div class=\"thumbContainer\" style=\"width:" + w + "px; max-width:1000px\"><div style=\"width:10000\">" + thumbs.join("") + "</div></div>",
              _onBlur: function() {
                if (noBlur == true) {
                  noBlur = false
                  dijit.focus(this.domNode.children[0]);
                }
                else {
                  dijit.popup.close(this);
                  setTimeout(dojo.hitch(this, this.destroyRecursive), 1);
                };
              },
              onOpen: function() {
                dijit.focus(this.domNode.children[0]);
              }
            }),
            around: node,
            orient:["above-alt", "above", "above-centered", "after"]

          });
        }, 1);
      }
    },
    error: handleError
  });

  return false;
};


function showImage(workTitle, name, workID, imageID, readOnly, selectNeeded) {


 dojo.xhrGet({
    url: "/redpendata/workimages.json",
    handleAs: "json",
    content: {
      id: workID
    },
    load: function(response) {
      if (!response.OK) handleError(response)
      else {

        console.log(response.images);
        var images = dojo.map(response.images, function(image) {
          var h = 500;
          if (image.width && image.height) {
            h = Math.round(0.55 * (dojo.coords(document.body).w - 10) * image.height / image.width);
          }
          return "<div id=\"IMG" + image.ID + "\"><iframe src=\"/redpen/work.html?readonly="+ (readOnly?"1":"0") +"&id=" + image.ID + "&width=" + image.width + "&height=" + image.height + "\" frameborder=\"0\" border=\"0\" scrolling=\"no\" width=\"100%\" height=\"" + h + "\" oldheight=\"" + h + "\"></iframe></div>"
        });

        images.unshift("<input id='FOCUS" + workID + "'type='checkbox' style='position: absolute;left:-150px;top:-150px' />");


        var shown = selectNeeded;

        var pane;
        dojo.forEach(dijit.byId("worksContainer").getChildren(), function(currentPage) {
          if (currentPage.id == "WORK" + workID )
            pane = currentPage;
        });
 
        if (!pane) {
          pane = new dijit.layout.ContentPane({
            title: "<span style=\"font-size:50%\">" + workTitle + "</span><br/><span style=\"font-size:50%\">" + name + "</span>",
            closable: true,
            content:  selectNeeded ? "<div>" + images.join("") + "</div>": "",
            id: "WORK" + workID,
            onShow: function(){
              if (!shown) {
                pane.setContent("<div>" + images.join("") + "</div>");
                if (imageID) 
                  dojo.query("#IMG" + imageID, pane.containerNode).forEach(function(node){
                   node.scrollIntoView(true);
                });
              } ;
              shown = true; 
              setTimeout(function(){
                var focusNode = dojo.byId("FOCUS" + workID);
                dijit.focus(focusNode);
              }, 100);
            },
            onClose: function(){
               dijit.byId("worksContainer").selectChild(dijit.byId("gridspage"));
               return true;
            }
          });
          dijit.byId("worksContainer").addChild(pane);


          dojo.connect(pane.containerNode, "onscroll", function() {
            var pos = this.scrollTop;
            var h = this.offsetHeight;
            dojo.query(">DIV>DIV", this).forEach(function(elem) {
              var c = dojo.coords(elem);
              var wnd = dojo.query("IFRAME", elem)[0].contentWindow;
              if (!wnd) 
                 return;
              if (!wnd.dojo) 
               return;
              wnd.dojo.query('DIV[dojotype="dojox.drawing.ui.dom.Toolbar"]').forEach(function(toolbar){
                var tbc = wnd.dojo.coords(toolbar);
                var r = 0;
                if (c.t < pos) {
                  if ((pos - c.t) > (c.h - tbc.h - 25)) {
                    r = c.h - tbc.h - 25
                  }
                  else {
                    r = pos - c.t
                  }
                };
                toolbar.style.top = r + "px";
              });
            });
          });
        }   

        dijit.focus(dijit.byId("worksContainer").domNode);
        if (selectNeeded) {
          dijit.byId("worksContainer").selectChild(pane);
          if (imageID) 
              dojo.query("#IMG" + imageID, pane.containerNode).forEach(function(node){
                 node.scrollIntoView(true);
              });
        }


      }
    },
    error: handleError
  });
  return false;
};


dojo.addOnLoad(function() {

  dojo.registerModulePath("redpen", "../../redpen");

  dojo.declare("noClassDndContainerObject", dojo.dnd.Source, {
    startup: function() {
      var r = this.inherited(arguments);
      noClassDndContainer = this;
      return r;
    }

  });

  var oldOnAfterRow = dojox.grid._TreeView.prototype.onAfterRow;
  dojo.extend(dojox.grid._TreeView, {

    onAfterRow: function(inRowIndex, cells, inRowNode) {
      // console.log("onAfterRow", inRowIndex, cells, inRowNode);
      if (inRowIndex >= 0) {
        var table = dojo.query("TABLE", inRowNode)[0];
        if (table) {
          var row = table.rows[0];
          var cell = row.cells[0];
          var rc = row.cells.length;

          var newrow = table.insertRow(0);
          newrow.innerHTML = row.innerHTML;

          for (var i = 0; i < rc; i++) {
            newrow.cells[i].innerHTML = "";
            dojo.addClass(newrow.cells[i], "hiddenCell");
          }
          newrow.height = 1;
          for (var i = 1; i < rc; i++)
          row.cells[i].style.display = "none";
          cell.colSpan = rc;
        }
      }
      oldOnAfterRow.apply(this, arguments);
    }

  });

  dojo.declare("classDndContainer", dojo.dnd.Source, {

    classID: null,

    copyState: function() {
      return false;
    },

    onDrop: function(source, nodes, copy) {
      console.log("onDrop", this, source, nodes, copy);

      dojo.forEach(nodes, dojo.hitch(this, function(node) {

        dojo.xhrGet({
          url: "/redpendata/addinclass.json",
          handleAs: "json",
          content: {
            student: node.getAttribute("studentid"),
            "class": this.classID
          },
          load: function(response) {
            if (!response.OK) handleError(response);
          },
          error: handleError
        });

      }));

      return this.inherited(arguments);
    }
  });


  dojo.xhrGet({
    url: "/redpendata/whoami.json",
    handleAs: "json",
    content: {
      email: dijit.byId("restorepwdemail").attr("value")
    },
    load: function(response) {
      if (response.OK) {
        logged(response);
      }
      else {
        dojo.byId("registration").style.display = "";
        dojo.fadeIn({
          node: dijit.byId("workSpacePane").domNode,
          duration: 700
        }).play();
      }
    },
    error: handleError
  });

});

function callMe(drawingObject){
  console.log(drawingObject);
  alert("callMe called.");
}

function setFocusFrame(imageID){
  dijit.focus( dojo.byId("IMG" + imageID).firstChild);
};


function setZoomFrame(imageID, zoom) {
  var frame = dojo.byId("IMG" + imageID).firstChild;
  frame.height = frame.getAttribute("oldheight") * zoom;
}

function scoreChanged(workID, score) {
  console.log(score);
  teacherWorksModel.fetchItemByIdentity({
    identity: workID,
    onItem: function(item) {
      console.log(item);
      grid.selection.deselectAll();
      teacherWorksStore.setValue(item, "score", score);
    }
  })
};


function drawingOptionsDialog(drawingObject) {

   var dialog = new dijit.Dialog({
      title: "<span style=\"font-size:150%\">canviar color</span>",
      content: dojo.cache("redpen", "colorChangeDialog.html"),
      onHide: function(){
         setTimeout(function(){
           dialog.destroyRecursive();
         }, 100);
      },

      doApply: function(){
          
       var colorSelect = dijit.byId("colorSelect");
       var fillSelect = dijit.byId("fillSelect");
       var widthSelect = dijit.byId("widthSelect");

       drawingObject.changeDefaults({
         norm: {
           fill: fillSelect.attr("value"),
           width: widthSelect.attr("value"),
           color: colorSelect.attr("value")
         },
         text: {
           color: colorSelect.attr("value")
         }
       });

       dialog.hide();

     },

      onShow: function(){

       var colorSelect = dijit.byId("colorSelect");
       var fillSelect = dijit.byId("fillSelect");
       var widthSelect = dijit.byId("widthSelect");
         

 
       var formatColor = function(value, name) {
         return "<div style='padding-top:2px;padding-bottom:2px'>" + 
           "<span style='width:12px;height:12px;border:1px solid black; background-color:" + 
           value + "'>&#160;&#160;&#160;&#160;&#160;&#160;</span>&#160;&#160;" + name + "</div>"
       };


       var formatWidth = function(value, name) {
         switch (value) {
           case 1:
             return "<div style='padding-top:2px'>" + 
               "<div style='display:inline-block;width:20px;height:14px;border:1px solid black; background-color:white'>" +  
               " <div style='width:100%;height:50%;border-bottom:" + value +"px solid black'>"
               +"</div></div><div style='display: inline-block;position: relative;top: -3px;padding-top:3px'>&#160;&#160;" + name + "</div></div>"
             break;
           case 3:
             return "<div style='padding-top:2px'>" + 
               "<div style='display:inline-block;width:20px;height:14px;border:1px solid black; background-color:white'>" +  
               " <div style='width:100%;height:43%;border-bottom:" + value +"px solid black'>"
               +"</div></div><div style='display: inline-block;position: relative;top: -5px;'>&#160;&#160;" + name + "</div></div>"
             break;
           case 5:
             return "<div style='padding-top:2px'>" + 
               "<div style='display:inline-block;width:20px;height:14px;border:1px solid black; background-color:white'>" +  
               " <div style='width:100%;height:36%;border-bottom:" + value +"px solid black'>"
               +"</div></div><div style='display: inline-block;position: relative;top: -5px;'>&#160;&#160;" + name + "</div></div>"
             break;
           case 7:
             return "<div style='padding-top:2px'>" + 
               "<div style='display:inline-block;width:20px;height:14px;border:1px solid black; background-color:white'>" +  
               " <div style='width:100%;height:29%;border-bottom:" + value +"px solid black'>"
               +"</div></div><div style='display: inline-block;position: relative;top: -5px;'>&#160;&#160;" + name + "</div></div>"
             break;
           case 9:
             return "<div style='padding-top:2px'>" + 
               "<div style='display:inline-block;width:20px;height:14px;border:1px solid black; background-color:white'>" +  
               " <div style='width:100%;height:21%;border-bottom:" + value +"px solid black'>"
               +"</div></div><div style='display: inline-block;position: relative;top: -5px;'>&#160;&#160;" + name + "</div></div>"
             break;
         };
         
       };


       var options = [];
       var colorNames = dojo.i18n.getLocalization("dojo", "colors");     

       for (var name in colorNames) {
          if (dojo.Color.named[name]) {
             options.push({
               label: formatColor(name, colorNames[name]),
               value: name
           });
         }
        };

        colorSelect.attr("options", dojo.clone(options));
        fillSelect.attr("options", dojo.clone(options));


        options = [];
        options.push({
          label: formatWidth(1, "molt fi"),
          value: 1
        });

        options.push({
          label: formatWidth(3, "fi"),
          value: 3
        });

        options.push({
          label: formatWidth(5, "normal"),
          value: 5
        });

        options.push({
          label: formatWidth(7, "gruixut"),
          value: 7
        });

        options.push({
          label: formatWidth(9, "molt gruixut"),
          value: 9
        });

        widthSelect.attr("options", dojo.clone(options));

console.log(drawingObject);

        colorSelect.attr("value", drawingObject.defaults.norm.color);
        fillSelect.attr("value", drawingObject.defaults.norm.fill);
        widthSelect.attr("value", drawingObject.defaults.norm.width);

      }
   });

   dialog.show(); 

}


